/*
Author : Nart Schinackow

Version : V.1.0.0

Compiler : MikroC Pro For Pic V.5.0.0.1

Description :
W5100 Is An Ethernet Module With Built In TCP/Ip Stack,
It Implements Many Protocols Tcp/UDP/ARP/....
THis Library uses Tcp The Udp  Is Not Implemented Yet Soon It Will Be,
I will Support Also Client Tcp And SErver Tcp .

Hardware: Any PIC WITH ENOUGH MEMORY :-)


Notes:
This Library Is Tested With Pic16f877A @ 10MHZ Crystal,
Working 100%.



Read The W5100 Data Sheet For More Info About Timing
*/
//#include "Stdio.h" //In LibStock
//#include "String.h"// In LibStock
//#include "IpAddress.h"// In LibStock
#include "SoftW5100.h"// The Library Included


// pin configurations
sfr sbit SOFTWARE_W5100_SCS at RB0_bit;
sfr sbit SOFTWARE_W5100_SDI at RB1_bit;
sfr sbit SOFTWARE_W5100_SDO at RB2_bit;
sfr sbit SOFTWARE_W5100_SCK at RB3_bit;
sfr sbit SOFWTARE_W5100_RESET at RB4_bit;

sfr sbit SOFTWARE_W5100_SCS_DIRECTION at TRISB0_bit;
sfr sbit SOFTWARE_W5100_SDI_DIRECTION at TRISB1_bit;
sfr sbit SOFTWARE_W5100_SDO_DIRECTION at TRISB2_bit;
sfr sbit SOFTWARE_W5100_SCK_DIRECTION at TRISB3_bit;
sfr sbit SOFWTARE_W5100_RESET_DIRECTION at TRISB4_bit;



char IpBuf[4]={192,168,1,15};//device ip address
char SubBuf[4]={255,255,255,0};//device subnet mask
char GWBuf[4]={192,168,1,1};//gateway buffer
char McBuf[6]={0x00, 0x14, 0xA5, 0x76, 0x19, 0x3f};//mac buffer
char Req[20];// request buffer

unsigned int i;

const char TestPage1[]=
"HTTP/1.1 200 OK\nContent-Type: text/html\n\n\
<html>\
<head>\
<title>WELCOME</title>\
<script>\
function Display()\
{\
  alert(\"Hello World!!, Its Working\");\
}\
</script>\
</head>\
<body>\
<h1 align=center>WELCOME TO TEST PAGE</h1>\
<h1 align=center><input type=\"button\" value=\"Press Me\" onclick=\"Display()\"></h1>\
</body>\
</html>";



unsigned int ConstStringLength(const char* String)// Returns The Length For A Const String
{
        unsigned int __c__;
        for(__c__=0;*String;String++)__c__++;
        return __c__;
}

void ProcessTcpRequest(char* Remote_Ip, char* Remote_Mac, unsigned int Remote_Port, unsigned int Local_port, unsigned int RequestLength)
{
  Soft_W5100_Get_Request(Req,20);//Upon Receive Copy The Request From W5100 Rx Buffer To Req[]
  Soft_W5100_Write_ConstPage(TestPage1,ConstStringLength(TestPage1)-1); //Fill W5100 Tx Buffer Test Page Upon Request
  SendPage();//Funtion For Sending The Data Out Of W5100 Tx Buffers
}



void main()
{
  Soft_W5100_Hardware_Init();//intialize hardware
  Soft_W5100_Init(IpBuf,SubBuf,GWBuf,McBuf);//Init W5100 Module
  //UART1_Init(9600);// Initialize Uart Used For Debugging
  delay_ms(100);// Wait A Little
  
 while(1)
 {
   Soft_W5100_UpdateSocketStatus();// Update Socket
 }

}