#line 1 "C:/Documents and Settings/Nart Schinackow/Desktop/79_software_version_w5100__built_in_tcp_ip_stack__module_demo_v1.0.0.0/Soft W5100 Lib TestProject/MyProject.c"
#line 1 "c:/documents and settings/nart schinackow/desktop/79_software_version_w5100__built_in_tcp_ip_stack__module_demo_v1.0.0.0/soft w5100 lib testproject/softw5100.h"
extern sfr sbit SOFTWARE_W5100_SCS;
extern sfr sbit SOFTWARE_W5100_SDI;
extern sfr sbit SOFTWARE_W5100_SDO;
extern sfr sbit SOFTWARE_W5100_SCK;
extern sfr sbit SOFWTARE_W5100_RESET;

extern sfr sbit SOFTWARE_W5100_SCS_DIRECTION;
extern sfr sbit SOFTWARE_W5100_SDI_DIRECTION;
extern sfr sbit SOFTWARE_W5100_SDO_DIRECTION;
extern sfr sbit SOFTWARE_W5100_SCK_DIRECTION;
extern sfr sbit SOFWTARE_W5100_RESET_DIRECTION;
#line 62 "c:/documents and settings/nart schinackow/desktop/79_software_version_w5100__built_in_tcp_ip_stack__module_demo_v1.0.0.0/soft w5100 lib testproject/softw5100.h"
unsigned char Socket0;
extern void ProcessTcpRequest(char* Remote_Ip, char* Remote_Mac, unsigned int Remote_Port, unsigned int Local_port, unsigned int RequestLength);
char _Remote_Ip_Address_[4];
char _Remote_Mac_Address_[6];
#line 1 "c:/documents and settings/nart schinackow/desktop/79_software_version_w5100__built_in_tcp_ip_stack__module_demo_v1.0.0.0/soft w5100 lib testproject/softw5100spi.c"
void SoftSpiWriteByte(char DataByte)
{
char ret;
unsigned char mask;

SOFTWARE_W5100_SCK=0;
mask = 0x80;
ret = 0;
SOFTWARE_W5100_SCS=0;
do {
SOFTWARE_W5100_SDO=0;
if (DataByte & mask)SOFTWARE_W5100_SDO=1;
SOFTWARE_W5100_SCK=1;
if (SOFTWARE_W5100_SDI) ret |= mask;
delay_us(1);
SOFTWARE_W5100_SCK=0;
mask = mask >> 1;
delay_us(1);
} while (mask != 0);
SOFTWARE_W5100_SCS=1;

}


char SoftSpiReadByte(char Clock)
{
char ret;
unsigned char mask;

SOFTWARE_W5100_SCK=0;
mask = 0x80;
ret = 0;
SOFTWARE_W5100_SCS=0;
do {
SOFTWARE_W5100_SDO=0;
if (Clock & mask)SOFTWARE_W5100_SDO=1;
SOFTWARE_W5100_SCK=1;
if (SOFTWARE_W5100_SDI) ret |= mask;
delay_us(1);
SOFTWARE_W5100_SCK=0;
mask = mask >> 1;
delay_us(1);
} while (mask != 0);
SOFTWARE_W5100_SCS=1;
return ret;
}
#line 1 "c:/documents and settings/nart schinackow/desktop/79_software_version_w5100__built_in_tcp_ip_stack__module_demo_v1.0.0.0/soft w5100 lib testproject/softw5100.c"
void Soft_W5100_Hardware_Init()
{
 SOFTWARE_W5100_SCS=1;
 SOFWTARE_W5100_RESET=1;
 SOFTWARE_W5100_SCK=0;
 SOFTWARE_W5100_SDO=0;
 SOFTWARE_W5100_SDI=0;

 SOFTWARE_W5100_SCS_DIRECTION=0;
 SOFWTARE_W5100_RESET_DIRECTION=0;
 SOFTWARE_W5100_SCK_DIRECTION=0;
 SOFTWARE_W5100_SDO_DIRECTION=0;
 SOFTWARE_W5100_SDI_DIRECTION=1;


 SOFTWARE_W5100_SCS=1;
 SOFWTARE_W5100_RESET=1;
 delay_ms(10);

 SOFWTARE_W5100_RESET=0;
 delay_us(2);
 SOFWTARE_W5100_RESET=1;
 delay_ms(10);
}


void Soft_W5100_Write_Byte(unsigned int Address,unsigned short DATA)
{
 unsigned char HighAddress;
 unsigned char LowAddress;
 HighAddress=(Address&0xff00)>>8;
 LowAddress=Address&0x00ff;

 SoftSpiWriteByte( 0xF0 );
 SoftSpiWriteByte(HighAddress);
 SoftSpiWriteByte(LowAddress);
 SoftSpiWriteByte(DATA);

}

unsigned char Soft_W5100_Read_Byte(unsigned int Address)
{
 unsigned char HighAddress;
 unsigned char LowAddress;
 char Val;
 HighAddress=(Address&0xff00)>>8;
 LowAddress=Address&0x00ff;


 SoftSpiWriteByte( 0x0F );
 SoftSpiWriteByte(HighAddress);
 SoftSpiWriteByte(LowAddress);
 Val=SoftSpiReadByte(0);

 return val;
}

void Soft_W5100_Init(char* IpAddress, char* Subnet, char* Gatway, char* MacAddress)
{
 Soft_W5100_Write_Byte( 0x0000 ,0x80);

 Soft_W5100_Write_Byte( 0X0001 ,Gatway[0]);
 Soft_W5100_Write_Byte( 0X0001 +1,Gatway[1]);
 Soft_W5100_Write_Byte( 0X0001 +2,Gatway[2]);
 Soft_W5100_Write_Byte( 0X0001 +3,Gatway[3]);

 Soft_W5100_Write_Byte( 0X0009 ,MacAddress[0]);
 Soft_W5100_Write_Byte( 0X0009 +1,MacAddress[1]);
 Soft_W5100_Write_Byte( 0X0009 +2,MacAddress[2]);
 Soft_W5100_Write_Byte( 0X0009 +3,MacAddress[3]);
 Soft_W5100_Write_Byte( 0X0009 +4,MacAddress[4]);
 Soft_W5100_Write_Byte( 0X0009 +5,MacAddress[5]);

 Soft_W5100_Write_Byte( 0X0005 ,Subnet[0]);
 Soft_W5100_Write_Byte( 0X0005 +1,Subnet[1]);
 Soft_W5100_Write_Byte( 0X0005 +2,Subnet[2]);
 Soft_W5100_Write_Byte( 0X0005 +3,Subnet[3]);

 Soft_W5100_Write_Byte( 0x000f ,IpAddress[0]);
 Soft_W5100_Write_Byte( 0x000f +1,IpAddress[1]);
 Soft_W5100_Write_Byte( 0x000f +2,IpAddress[2]);
 Soft_W5100_Write_Byte( 0x000f +3,IpAddress[3]);

 Soft_W5100_Write_Byte( 0x001A , 0x05 );
 Soft_W5100_Write_Byte( 0x001B , 0x05 );
}

void Soft_W5100_CloseSocket()
{

 Soft_W5100_Write_Byte( 0x0401 , 0x10 );

 while(Soft_W5100_Read_Byte( 0x0401 ));
}

void Soft_W5100_DisconnectSocket()
{

 Soft_W5100_Write_Byte( 0x0401 , 0x08 );

 while(Soft_W5100_Read_Byte( 0x0401 ));
}

unsigned char Soft_W5100_ReadStatusRegister()
{
 return Soft_W5100_Read_Byte( 0x0403 );
}

unsigned char Soft_W5100_IsSocketClosed()
{
 return (Soft_W5100_Read_Byte( 0x0403 ) ==  0x00 );
}

unsigned char Soft_W5100_IsSocketInitialized()
{
 return (Soft_W5100_Read_Byte( 0x0403 ) ==  0x13 );
}

unsigned char Soft_W5100_IsSocketListening()
{
 return (Soft_W5100_Read_Byte( 0x0403 ) ==  0x14 );
}




unsigned char Soft_W5100_InitSocket(unsigned int PORT)
{
 unsigned char Error;
 unsigned char HighByte;
 unsigned char LowByte;

 Error=1;

 if (Soft_W5100_IsSocketClosed())Soft_W5100_CloseSocket();


 Soft_W5100_Write_Byte( 0x0400 , 0x01 );


 HighByte=(PORT&0xff00)>>8;
 LowByte=(PORT&0x00ff);
 Soft_W5100_Write_Byte( 0x0404 ,HighByte);
 Soft_W5100_Write_Byte( 0x0404 +1,LowByte);

 Soft_W5100_Write_Byte( 0x0401 , 0x01 );


 while(Soft_W5100_Read_Byte( 0x0401 ));


 if (Soft_W5100_IsSocketInitialized())
 Error=0;
 else
 Soft_W5100_CloseSocket();

 return Error;
}


unsigned char Soft_W5100_StartListening()
{
 unsigned char Error;
 Error=1;

 if (Soft_W5100_IsSocketInitialized)
 {

 Soft_W5100_Write_Byte( 0x0401 , 0x02 );

 while(Soft_W5100_Read_Byte( 0x0401 ));

 if (Soft_W5100_IsSocketListening())
 Error=0;
 else
 Soft_W5100_CloseSocket();
 }
 return Error;
}


unsigned char Soft_W5100_Write_Page(char* TxBuffer, unsigned int SendSize)
{

unsigned int FreeSize;
unsigned int Loop;
unsigned int TimeOut;
unsigned int MemoryPointer;
unsigned int PhisycalAddress;
unsigned char HighByte;
unsigned char LowByte;



FreeSize=(unsigned int)Soft_W5100_Read_Byte( 0x0420 );
FreeSize=FreeSize<<8;
FreeSize=FreeSize|(unsigned int)Soft_W5100_Read_Byte( 0x0420 +1);


TimeOut=0;
while (FreeSize < SendSize) {
delay_ms(1);
FreeSize=(unsigned int)Soft_W5100_Read_Byte( 0x0420 );
FreeSize=FreeSize<<8;
FreeSize=FreeSize|(unsigned int)Soft_W5100_Read_Byte( 0x0420 +1);
if (TimeOut++ > 1000){
Soft_W5100_DisconnectSocket();
return 1;}
}


MemoryPointer =(unsigned int)Soft_W5100_Read_Byte( 0x0424 );
MemoryPointer=MemoryPointer<<8;
MemoryPointer=MemoryPointer|(unsigned int)Soft_W5100_Read_Byte( 0x0424 +1);


for(Loop=0;Loop<SendSize;Loop++,MemoryPointer++)
{

PhisycalAddress =  0x4000  + (MemoryPointer& 0x07FF );

Soft_W5100_Write_Byte(PhisycalAddress,TxBuffer[Loop]);
}


HighByte=(MemoryPointer&0xff00)>>8;
LowByte=MemoryPointer&0x00ff;
Soft_W5100_Write_Byte( 0x0424 ,HighByte);
Soft_W5100_Write_Byte( 0x0424 +1,LowByte);

return 0;
}



unsigned char Soft_W5100_Write_ConstPage(const char* TxBuffer, unsigned int SendSize)
{

unsigned int FreeSize;
unsigned int Loop;
unsigned int TimeOut;
unsigned int MemoryPointer;
unsigned int PhisycalAddress;
unsigned char HighByte;
unsigned char LowByte;



FreeSize=(unsigned int)Soft_W5100_Read_Byte( 0x0420 );
FreeSize=FreeSize<<8;
FreeSize=FreeSize|(unsigned int)Soft_W5100_Read_Byte( 0x0420 +1);


TimeOut=0;
while (FreeSize < SendSize) {
delay_ms(1);
FreeSize=(unsigned int)Soft_W5100_Read_Byte( 0x0420 );
FreeSize=FreeSize<<8;
FreeSize=FreeSize|(unsigned int)Soft_W5100_Read_Byte( 0x0420 +1);
if (TimeOut++ > 1000){
Soft_W5100_DisconnectSocket();
return 1;}
}


MemoryPointer =(unsigned int)Soft_W5100_Read_Byte( 0x0424 );
MemoryPointer=MemoryPointer<<8;
MemoryPointer=MemoryPointer|(unsigned int)Soft_W5100_Read_Byte( 0x0424 +1);


for(Loop=0;Loop<SendSize;Loop++,MemoryPointer++)
{

PhisycalAddress =  0x4000  + (MemoryPointer& 0x07FF );

Soft_W5100_Write_Byte(PhisycalAddress,TxBuffer[Loop]);
}


HighByte=(MemoryPointer&0xff00)>>8;
LowByte=MemoryPointer&0x00ff;
Soft_W5100_Write_Byte( 0x0424 ,HighByte);
Soft_W5100_Write_Byte( 0x0424 +1,LowByte);


return 0;
}



unsigned char Soft_W5100_Get_Request(char* ReceiveBuffer, unsigned int ReceiveSize)
{
unsigned int Loop;
unsigned int MemoryPointer;
unsigned int PhisycalAddress;
unsigned char HighByte;
unsigned char LowByte;





MemoryPointer =(unsigned int)Soft_W5100_Read_Byte( 0x0428 );
MemoryPointer=MemoryPointer<<8;
MemoryPointer=MemoryPointer|(unsigned int)Soft_W5100_Read_Byte( 0x0428 +1);


for(Loop=0;Loop<ReceiveSize-1;Loop++,MemoryPointer++)
{

PhisycalAddress =  0x6000  + (MemoryPointer& 0x07FF );

ReceiveBuffer[Loop]=Soft_W5100_Read_Byte(PhisycalAddress);
}
ReceiveBuffer[Loop]='\0';

HighByte=(MemoryPointer&0xff00)>>8;
LowByte=MemoryPointer&0x00ff;
Soft_W5100_Write_Byte( 0x0428 ,HighByte);
Soft_W5100_Write_Byte( 0x0428 +1,LowByte);


Soft_W5100_Write_Byte( 0x0401 , 0x40 );
delay_us(10);

return 0;
}

unsigned int Soft_W5100_GetRequestSize()
{
 unsigned int Size;
 Size=0;
 Size=(unsigned int)Soft_W5100_Read_Byte( 0x0426 );
 Size=Size<<8;
 Size=Size|(unsigned int)Soft_W5100_Read_Byte( 0x0426 +1);
 return Size;
}


unsigned int Soft_W5100_GetLocalPort()
{
 unsigned int Val;
 Val=(unsigned int)Soft_W5100_Read_Byte( 0x0404 );
 Val=Val<<8;
 Val=Val|(unsigned int)Soft_W5100_Read_Byte( 0x0404 +1);
 return Val;
}

unsigned int Soft_W5100_GetRemotePort()
{
 unsigned int Val;
 Val=(unsigned int)Soft_W5100_Read_Byte( 0x0410 );
 Val=Val<<8;
 Val=Val|(unsigned int)Soft_W5100_Read_Byte( 0x0410 +1);
 return Val;
}

char* Soft_W5100_GetRemoteIp()
{
_Remote_Ip_Address_[0]=Soft_W5100_Read_Byte( 0x040C );
_Remote_Ip_Address_[1]=Soft_W5100_Read_Byte( 0x040C +1);
_Remote_Ip_Address_[2]=Soft_W5100_Read_Byte( 0x040C +2);
_Remote_Ip_Address_[3]=Soft_W5100_Read_Byte( 0x040C +3);
return _Remote_Ip_Address_;
}

char* Soft_W5100_GetRemoteMac()
{
_Remote_Mac_Address_[0]=Soft_W5100_Read_Byte( 0x0406 );
_Remote_Mac_Address_[1]=Soft_W5100_Read_Byte( 0x0406 +1);
_Remote_Mac_Address_[2]=Soft_W5100_Read_Byte( 0x0406 +2);
_Remote_Mac_Address_[3]=Soft_W5100_Read_Byte( 0x0406 +3);
_Remote_Mac_Address_[4]=Soft_W5100_Read_Byte( 0x0406 +4);
_Remote_Mac_Address_[5]=Soft_W5100_Read_Byte( 0x0406 +5);
return _Remote_Mac_Address_;
}

char* Soft_W5100_GetLocal_IpAddress()
{
 _Remote_Ip_Address_[0]=Soft_W5100_Read_Byte( 0x000f );
 _Remote_Ip_Address_[1]=Soft_W5100_Read_Byte( 0x000f +1);
 _Remote_Ip_Address_[2]=Soft_W5100_Read_Byte( 0x000f +2);
 _Remote_Ip_Address_[3]=Soft_W5100_Read_Byte( 0x000f +3);
 return _Remote_Ip_Address_;
}

char* Soft_W5100_GetLocal_MacAddress()
{
 _Remote_Mac_Address_[0]=Soft_W5100_Read_Byte( 0X0009 );
 _Remote_Mac_Address_[1]=Soft_W5100_Read_Byte( 0X0009 +1);
 _Remote_Mac_Address_[2]=Soft_W5100_Read_Byte( 0X0009 +2);
 _Remote_Mac_Address_[3]=Soft_W5100_Read_Byte( 0X0009 +3);
 _Remote_Mac_Address_[4]=Soft_W5100_Read_Byte( 0X0009 +4);
 _Remote_Mac_Address_[5]=Soft_W5100_Read_Byte( 0X0009 +5);
 return _Remote_Mac_Address_;
}

char* Soft_W5100_GetLocal_SubnetMask()
{
 _Remote_Ip_Address_[0]=Soft_W5100_Read_Byte( 0X0005 );
 _Remote_Ip_Address_[1]=Soft_W5100_Read_Byte( 0X0005 +1);
 _Remote_Ip_Address_[2]=Soft_W5100_Read_Byte( 0X0005 +2);
 _Remote_Ip_Address_[3]=Soft_W5100_Read_Byte( 0X0005 +3);
 return _Remote_Ip_Address_;
}

char* Soft_W5100_GetLocal_DefaultGateway()
{
 _Remote_Ip_Address_[0]=Soft_W5100_Read_Byte( 0X0001 );
 _Remote_Ip_Address_[1]=Soft_W5100_Read_Byte( 0X0001 +1);
 _Remote_Ip_Address_[2]=Soft_W5100_Read_Byte( 0X0001 +2);
 _Remote_Ip_Address_[3]=Soft_W5100_Read_Byte( 0X0001 +3);
 return _Remote_Ip_Address_;
}


void Soft_W5100_UpdateSocketStatus()
{
 unsigned int RequestSize;
 unsigned int rp;
 char* rmac;
 unsigned int lp;
 char* rip;

 Socket0 =Soft_W5100_ReadStatusRegister();
 switch(Socket0)
 {

 case  0x00 :
 if (Soft_W5100_InitSocket(80)==0) {
 if (Soft_W5100_StartListening()==0);
 delay_ms(1000);
 }
 break;


 case  0x17 :
 RequestSize=Soft_W5100_GetRequestSize();
 if(RequestSize>0){
 rmac=Soft_W5100_GetRemoteMac();
 rip=Soft_W5100_GetRemoteIp();
 lp=Soft_W5100_GetLocalPort();
 rp=Soft_W5100_GetRemotePort();
 ProcessTcpRequest(rip,rmac,rp,lp,RequestSize);
 Soft_W5100_DisconnectSocket();}
 break;

 default:
 Soft_W5100_CloseSocket();
 break;
 }
}


void SendPage()
{

Soft_W5100_Write_Byte( 0x0401 , 0x20 );

while(Soft_W5100_Read_Byte( 0x0401 ));
}
#line 32 "C:/Documents and Settings/Nart Schinackow/Desktop/79_software_version_w5100__built_in_tcp_ip_stack__module_demo_v1.0.0.0/Soft W5100 Lib TestProject/MyProject.c"
sfr sbit SOFTWARE_W5100_SCS at RB0_bit;
sfr sbit SOFTWARE_W5100_SDI at RB1_bit;
sfr sbit SOFTWARE_W5100_SDO at RB2_bit;
sfr sbit SOFTWARE_W5100_SCK at RB3_bit;
sfr sbit SOFWTARE_W5100_RESET at RB4_bit;

sfr sbit SOFTWARE_W5100_SCS_DIRECTION at TRISB0_bit;
sfr sbit SOFTWARE_W5100_SDI_DIRECTION at TRISB1_bit;
sfr sbit SOFTWARE_W5100_SDO_DIRECTION at TRISB2_bit;
sfr sbit SOFTWARE_W5100_SCK_DIRECTION at TRISB3_bit;
sfr sbit SOFWTARE_W5100_RESET_DIRECTION at TRISB4_bit;



char IpBuf[4]={192,168,1,15};
char SubBuf[4]={255,255,255,0};
char GWBuf[4]={192,168,1,1};
char McBuf[6]={0x00, 0x14, 0xA5, 0x76, 0x19, 0x3f};
char Req[20];

unsigned int i;

const char TestPage1[]=
#line 70 "C:/Documents and Settings/Nart Schinackow/Desktop/79_software_version_w5100__built_in_tcp_ip_stack__module_demo_v1.0.0.0/Soft W5100 Lib TestProject/MyProject.c"
"HTTP/1.1 200 OK\nContent-Type: text/html\n\n<html><head><title>WELCOME</title><script>function Display(){  alert(\"Hello World!!, Its Working\");}</script></head><body><h1 align=center>WELCOME TO TEST PAGE</h1><h1 align=center><input type=\"button\" value=\"Press Me\" onclick=\"Display()\"></h1></body></html>";



unsigned int ConstStringLength(const char* String)
{
 unsigned int __c__;
 for(__c__=0;*String;String++)__c__++;
 return __c__;
}

void ProcessTcpRequest(char* Remote_Ip, char* Remote_Mac, unsigned int Remote_Port, unsigned int Local_port, unsigned int RequestLength)
{
 Soft_W5100_Get_Request(Req,20);
 Soft_W5100_Write_ConstPage(TestPage1,ConstStringLength(TestPage1)-1);
 SendPage();
}



void main()
{
 Soft_W5100_Hardware_Init();
 Soft_W5100_Init(IpBuf,SubBuf,GWBuf,McBuf);

 delay_ms(100);

 while(1)
 {
 Soft_W5100_UpdateSocketStatus();
 }

}
